/*******************************************************************
* ARexx Script: Alarmist_DropObj.rexx                              *
* Version.....: 1.00 (14.05.96)                                    *
* ---------------------------------------------------------------- *
* This is the default ARexx script for Drop Objects in Alarmist    *
* You determin what happens to icons that are dropped onto the     *
* Alarmist windows. The script is called with the filename as an   *
* argument. This script will create an event that calls file that  *
* dropped.                                                         *
*******************************************************************/

filename = ARG(1)

/* get the completed minutes since mindnight */
minutes = time(m)

/* translate minutes to Alarm Time */
hour = trunc(minutes / 60, 0)
min  = minutes - hour * 60 + 5

/* Get out Event name from the supplies filename */
index = lastpos("/", filename)

if (index < 1) then
	index = lastpos(":", filename)

if (index > 0) then
	name = 'Dropped: 'right(filename, (Length(filename) - index))

/* Tell Alarmist to insert a new Alarm */
/* Remember to enclose arguments that contain spaces in double-quotes " */
address alarmist

'new name "'name'" ahour 'hour' amin 'min' aexec "'filename'" aexectype 1'

/* Note: After an Alarm is inserted it will become the
   active entry in the list. So we can now just call up
   the Event Edit Window to make changes to the Alarm.  */
'editwindow'

/* End */