/*******************************************************************
* ARexx Script: Alarmist_NextAlarm.rexx                            *
* Version.....: 1.00 (23.08.96)                                    *
* ---------------------------------------------------------------- *
* This script queries Alarmist for the next occuring Alarm. If     *
* there is one then it informs the user of the name and time of    *
* the event via the program 'Talk.'                                *
*                                                                  *
* NOTE: This script has nothing to do with Warning events! This    *
*       script will inform you about the next occuring Alarm no    *
*       matter what the next Warn event is.                        *
*                                                                  *
* You could even assign this script to a Hot-Key in Tool Manager   *
* to find out what the next Alarm is and when it will occur.       *
*                                                                  *
* If you wanted to find out when the next Warn event is, you could *
* call the script "Everyday:rexx/Alarmist_Warn.rexx". If you are   *
* using this previous script as the Warn event (set in Alarmist    *
* configuration) you could simply send the command 'dowarn' to     *
* to Alarmist and it will ewxecute the script for you.             *
*******************************************************************/

options results

address Alarmist

getnextalarm
nextalarm = result

/* if there isn't a 'next' alarm then quit */
if (nextalarm = '' | nextalarm = 0) then
do
	call Talk("no more a larms for today")
	
	exit(0)
end

/* get computer time */
clock_minutes = time(m);

/* get name */
getfield entry nextalarm 1
name = result

/* get hour */
getfield entry nextalarm 3
hour = result

/* get minute */
getfield entry nextalarm 4
minute = result

alarm_minutes = hour * 60 + minute

/* calculate difference between alarm and computer time */
diff_minutes = alarm_minutes - clock_minutes

diff_hours   = diff_minutes % 60
diff_minutes = diff_minutes // 60
output = ''

/* put together the output string */
if (diff_hours > 0) then
do
	output = '%n'diff_hours' hour'

	if (diff_hours > 1) then
		output = output || 's'
end

if (diff_minutes > 0) then
do
	output = output || '%n'diff_minutes' min ut'

	if (diff_minutes > 1) then
		output = output || 's'
end

/* Talk to the user */

speech = '->2 'name' will a cur in 'output

call Talk(speech)

/* It's as easy as that ! */

exit (0)

/*********************************************/
/* Check for TALK ARexx port or call program */
/*********************************************/

Talk: PROCEDURE

parse ARG speech

if (show('p', 'TALK')) then
do
	address TALK

	speech
end
else
do
	address command
	
	c:talk speech
end

return (0)

/*********************************************/

/* End */