/*******************************************************************
* ARexx Script: Alarmist_Reminder.rexx                             *
* Version.....: 1.00 (14.05.96)                                    *
* ---------------------------------------------------------------- *
* This is a simple script that you can use to create reminders.    *
*  eg. You turn the hose on to water the garden and want to be     *
*  reminded to turn it off after a certain time.                   *
* It creates a new alarm in 'DelayMinutes' time from the present.  *
*******************************************************************/

options results

/* get the reminder time (minutes) */
parse arg DelayMinutes .

/* not necessarily called from Alarmist so we'll set host name */
address Alarmist

/* if no Delay Minutes argument was given then give a default value */
if (DelayMinutes <= 0) then
	DelayMinutes = 10

/* get computer time */
clock_minutes = time(m);

/* calculate Alarm time */
minute = (clock_minutes + DelayMinutes) // 1440

hour   = minute % 60
minute = minute // 60

/* insert new event into Alarmist */
/* it will have an infinite snooze setting so you'll always remember */
'new name "Reminder Event" ahour 'hour' amin 'minute' aexec "c:talk -w2 This is a reminder"  ssec 20 stimes 100'

/* End */