/*******************************************************************
* ARexx Script: Locate_CryptNotes.rexx                             *
* Version.....: 1.00 (14.05.96)                                    *
* ---------------------------------------------------------------- *
* Encrypt and Decrypt External Note Files.                         *
* This script will try to find an External Note data file for the  *
* currently active entry. If it finds one it will invoke the       *
* program 'Coder' to encrypt it. Now you need to have previously   *
* defined your password in a Global Environmental variable with    *
* 'SetEnv lp password' from a CLI. You might install this script   *
* to one of the ARexx Script locations in the Locate ARexx Menu.   *
*******************************************************************/

options results

parse arg password

/* get host name */
host = address()

address value host

/* find out what the name of the Note File is OR quit */
getextnotename
name = result

if (rc ~= 0) then
	exit(5)

/* see if there has been a passowrd defined OR quit */
if (password = '') then
do
	if (open('LP', 'env:LP', 'R') ~= 0) then
	do
		password = readln('LP')
		close('LP')
	end
end

if (password = '') then
	exit(0)

/* get the directory where the Exteranl Notes are kept */
getextnotedir
path = result

/* make our new pathname */
if (right(path, 1) != ':' & right(path, 1) != '/') then
	path = path || '/'

path = path || name

/* we want to know if it is really there */
if (~Exists(path)) then
	exit(5)

/* invoke Coder to do the job */
/* Notice that we don't specify a code or decode option */
/* because Coder will autodetect the state of the file. */
address command

'c:coder >NIL: "'path'" p='password

address value host

/* tell locate to examine the file again - look it's encrypted 8) */
noteexamine

/* End */