/*******************************************************************
* ARexx Script: OnTime_RemoveOldEvents.rexx                        *
* Version.....: 1.10 (12.03.97)                                    *
* ---------------------------------------------------------------- *
* This script will delete all old Events relative to the present   *
* day. This is done by setting the Event filter to show only old   *
* Events. The script asks the user to confirm the action.          *
* NOTE: Old Events are ones that have no repetiton set. You don't  *
* have to worry about this because the Event filter knows this.    *
*******************************************************************/

options results

/* Make sure the Event list doesn't get updated more than once */
'listquiet event 1'

/* Set the Event filter string to show all old Events */
'filterstring event old'

/* !! We want old Event relative to the present date !! */
'filterdate today'

/* Make sure the Event filter is turned on */ 
'filter event 1'

/* How many old Events are shown ? */
'getentries events'
entries_shown = result

/* Okay, now we can update the Event List */
'listquiet event 0'

/* Exit if there are no shown entries */
if (entries_shown = 0) then
	exit

message = 'Remove 'entries_shown' old Events'

'requester title "Remove Request" button "Remove|_*Cancel" 'message

if (result == 0) then
	exit

/* Select all shown Events */
'select event all'

/* Remove these entries */
'remove event'

/* End */
