/*******************************************************************
* ARexx Script: OnTime_ToDoList.rexx                               *
* Version.....: 1.10 (12.03.97)                                    *
* ---------------------------------------------------------------- *
* This script does a specialised print of Tasks for 'Today'.       *
* It outputs in the following format:                              *
*                                                                  *
* Tasks for 11 Mar 1997                                            *
* ---------------------                                            *
* H - Do: Win  a million dollars                                   *
* h - Visit: Randal                                                *
* n - Do: Wash Car                                                 *
* l - Visit: Philip                                                *
* L - Phone: Blah, Blah, Blah                                      *
*******************************************************************/

options results

/* If the script isn't run from On-Time */
Address OnTime

/* Output specifiers */
outputfile = 'PRT:'
outputdate = 'today'

reqtitle = '"Print To-Do-List"'

/* Ask user for confirmation */
requester title reqtitle button 'Print|Cancel' message 'Output a To-Do-List to "'outputfile'" ?'

if (result = 0) then
	exit(0)

/* Set Task filter string to show only Tasks for a single day */
filterstring task day 1

/* Set Task filter date to today */
filterdate   task today

/* Make sure filter is turned on */
filter       task 1

/* How many Tasks shown ? */
getentries task
tasks = result

if (tasks = 0) then
do
	requester title reqtitle button 'Okay' message 'There are no Tasks for Today!'
	exit (0)
end

/* Setup priority name array */
pri.0 = 'L'
pri.1 = 'l'
pri.2 = 'n'
pri.3 = 'h'
pri.4 = 'H'

if (open(handle, outputfile, 'w') = 0) then
do
	requester title reqtitle button 'Okay' message 'Unable to open "'outputfile'" for output!'
	exit (10)
end

/* Make title */
'dateinfo date 'outputdate
todaydate = result

title = 'Tasks for 'todaydate
underline = copies('-', length(title))

/* Output title and underline */
writeln(handle, title)
writeln(handle, underline)

/* Output Tasks */
do i = 1 to tasks

	/* Make sure we don't get ant list titles */
	getfield task entry i type

	if (result = 1) then
	do
		/* Get Task name */
		getfield task entry i 1
		name = result
	
		/* Get Task priority */
		getfield task entry i 5
		priority = result

		writeln(handle, pri.priority' - 'name)
	end
end

close(handle)

/* End */
